"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LayerRuleBindings {
    constructor(bidings) {
        this.validate(bidings);
        this.layers = new Map(bidings.map(({ layer }) => [layer.name, layer]));
        this.expressions = new Map(bidings.map(({ layer, expressions }) => [layer.name, expressions]));
    }
    expressionFor(layer) {
        return this.expressions.get(layer.name) || [];
    }
    validate(bidings) {
        const layers = bidings.map(({ layer }) => layer);
        const nameDuplicated = layers.find((layer, i) => layers.findIndex(({ name }) => name === layer.name) !== i);
        if (nameDuplicated) {
            throw new Error(`Found duplicated name in layers: "${nameDuplicated.name}"`);
        }
    }
}
exports.LayerRuleBindings = LayerRuleBindings;
