import { DLintModule, DLintNode, DLintError, RuleUnitName, DLintLayer } from '@dlint/core';
export declare enum RuleAllowanceStatus {
    ALLOWED = "allowed",
    DISALLOWED = "disallowed"
}
/**
 * Status of applying a rule unit to a DLintModule
 */
interface ModuleAppliedStatus {
    ruleUnitName: RuleUnitName;
    status: RuleAllowanceStatus;
    module: DLintModule;
}
/**
 * Result of applying a specific rule unit to a DLintNode
 */
export declare class NodeAppliedResult {
    node: DLintNode;
    ruleUnitName: RuleUnitName;
    private moduleStatusMap;
    constructor(node: DLintNode, ruleUnitName: RuleUnitName);
    allow(module: DLintModule): void;
    disallow(module: DLintModule): void;
    statuses(): ModuleAppliedStatus[];
}
/**
 * Reduce NodeAppliedResult array to single result
 */
export declare const reduceDisallowedResults: (layer: DLintLayer, node: DLintNode, results: NodeAppliedResult[]) => DLintError;
export {};
