"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RuleAppliedResult_1 = require("./RuleAppliedResult");
class RuleUnitBase {
    constructor() {
        this.name = 'Base';
        this.positive = true;
    }
    apply(node) {
        const result = new RuleAppliedResult_1.NodeAppliedResult(node, this.name);
        for (const module of this.target(node.fanout)) {
            if (this.judge(module)) {
                if (this.positive) {
                    result.allow(module);
                }
                else {
                    result.disallow(module);
                }
            }
        }
        return result;
    }
    // must be overroded
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    target(fanout) {
        throw new Error('Not implemented');
    }
    // must be overrode
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    judge(module) {
        throw new Error('Not implemented');
    }
}
exports.RuleUnitBase = RuleUnitBase;
