import { Fanout, LocalModule, PackageModule, DLintLayer, RuleUnitName } from '@dlint/core';
import { RuleUnitBase } from './RuleUnitBase';
export declare class AllowAll extends RuleUnitBase {
    name: RuleUnitName;
    protected positive: boolean;
    protected target(fanout: Fanout): import("@dlint/core").DLintModule[];
    protected judge(): boolean;
}
export declare class AllowAllLayers extends RuleUnitBase {
    name: RuleUnitName;
    protected positive: boolean;
    protected target(fanout: Fanout): LocalModule[];
    protected judge(): boolean;
}
export declare class AllowAllPackages extends RuleUnitBase {
    name: RuleUnitName;
    protected positive: boolean;
    protected target(fanout: Fanout): (PackageModule | import("@dlint/core").BuiltinModule)[];
    protected judge(): boolean;
}
export declare class AllowAllNodejs extends RuleUnitBase {
    name: RuleUnitName;
    protected positive: boolean;
    protected target(fanout: Fanout): import("@dlint/core").BuiltinModule[];
    protected judge(): boolean;
}
export declare class AllowAllJson extends RuleUnitBase {
    name: RuleUnitName;
    protected positive: boolean;
    protected target(fanout: Fanout): LocalModule[];
    protected judge(module: LocalModule): boolean;
}
export declare class AllowLayers extends RuleUnitBase {
    name: RuleUnitName;
    layers: DLintLayer[];
    protected positive: boolean;
    constructor(layers: DLintLayer[]);
    protected target(fanout: Fanout): LocalModule[];
    protected judge(module: LocalModule): boolean;
}
export declare class AllowPackages extends RuleUnitBase {
    name: RuleUnitName;
    packages: string[];
    protected positive: boolean;
    constructor(packages: string[]);
    protected target(fanout: Fanout): (PackageModule | import("@dlint/core").BuiltinModule)[];
    protected judge(module: PackageModule): boolean;
}
export declare class AllowSelfLayer extends RuleUnitBase {
    name: RuleUnitName;
    selfLayer: DLintLayer;
    protected positive: boolean;
    constructor(selfLayer: DLintLayer);
    protected target(fanout: Fanout): LocalModule[];
    protected judge(module: LocalModule): boolean;
}
export declare class DisallowAll extends AllowAll {
    name: RuleUnitName;
    protected positive: boolean;
}
export declare class DisallowLayers extends AllowLayers {
    name: RuleUnitName;
    protected positive: boolean;
}
export declare class DisallowPackages extends AllowPackages {
    name: RuleUnitName;
    protected positive: boolean;
}
export declare class DisallowAllLayers extends AllowAllLayers {
    name: RuleUnitName;
    protected positive: boolean;
}
export declare class DisallowAllPackages extends AllowAllPackages {
    name: RuleUnitName;
    protected positive: boolean;
}
export declare class DisallowAllNodejs extends AllowAllNodejs {
    name: RuleUnitName;
    protected positive: boolean;
}
export declare class DisallowAllJson extends AllowAllJson {
    name: RuleUnitName;
    protected positive: boolean;
}
export declare class DisallowSelfLayer extends AllowSelfLayer {
    name: RuleUnitName;
    protected positive: boolean;
}
